                     MEMBER
!==============================================================================
                     MAP
                       INCLUDE('MHProper.cpy')
                     END
                     INCLUDE('MHProper.inc')
!==============================================================================
Proper PROCEDURE(STRING Name)
P MHProperClass
  CODE
  RETURN P.ToProper(Name)
!==============================================================================
ProperControl PROCEDURE(SIGNED Feq)!,STRING,PROC
P MHProperClass
  CODE
  RETURN P.AcceptControl(Feq)
!==============================================================================
!==============================================================================
MHProperClass.AcceptControl PROCEDURE(SIGNED Feq)!,STRING
  CODE
  CHANGE(Feq, SELF.ToProper(CONTENTS(Feq)))
  RETURN SELF.Name
!==============================================================================
MHProperClass.AddForcedWord PROCEDURE(STRING Word,<BYTE NotAtStart>)
  CODE
  SELF.ForcedWord.Length       = LEN(CLIP(Word))

  SELF.ForcedWord.Word        &= NEW STRING(SELF.ForcedWord.Length)
  SELF.ForcedWord.Word         = Word

  SELF.ForcedWord.PaddedUpper &= NEW STRING(SELF.ForcedWord.Length+2)
  SELF.ForcedWord.PaddedUpper  = ' ' & UPPER(Word) & ' '

  SELF.ForcedWord.NotAtStart   = NotAtStart

  ADD(SELF.ForcedWord)
!==============================================================================
MHProperClass.Construct PROCEDURE
  CODE
  SELF.ForcedWord &= NEW MHProperForcedWordQueue

  !Degrees
  SELF.AddForcedWord('MD')
  SELF.AddForcedWord('PhD')
  SELF.AddForcedWord('DDS')

  !Directions
  Self.Addforcedword('ne')
  Self.Addforcedword('nw')
  Self.Addforcedword('se')
  Self.Addforcedword('sw')

  !Roman Numerals
  SELF.AddForcedWord('II')                !2
  SELF.AddForcedWord('III')               !3
  SELF.AddForcedWord('IV')                !4
  SELF.AddForcedWord('VI')                !6
  SELF.AddForcedWord('VII')               !7
  SELF.AddForcedWord('VIII')              !8
  SELF.AddForcedWord('IX')                !9
  SELF.AddForcedWord('XI')                !11
  SELF.AddForcedWord('XII')               !12
  SELF.AddForcedWord('XIII')              !13
  SELF.AddForcedWord('XIV')               !14
  SELF.AddForcedWord('XV')                !15
  SELF.AddForcedWord('XVI')               !16
  SELF.AddForcedWord('XVII')              !17
  SELF.AddForcedWord('XVIII')             !18
  SELF.AddForcedWord('XIX')               !19
  SELF.AddForcedWord('XX')                !20
  SELF.AddForcedWord('XXI')               !21
  SELF.AddForcedWord('XXII')              !22
  SELF.AddForcedWord('XXIII')             !23
  SELF.AddForcedWord('XXIV')              !24
  SELF.AddForcedWord('XXV')               !25
  SELF.AddForcedWord('XXVI')              !26
  SELF.AddForcedWord('XXVII')             !27
  SELF.AddForcedWord('XXVIII')            !28
  SELF.AddForcedWord('XXIX')              !29
  SELF.AddForcedWord('XXX')               !30
  SELF.AddForcedWord('XXXI')              !31
  SELF.AddForcedWord('XXXII')             !32
  SELF.AddForcedWord('XXXIII')            !33
  SELF.AddForcedWord('XXXIV')             !34
  SELF.AddForcedWord('XXXV')              !35
  SELF.AddForcedWord('XXXVI')             !36
  SELF.AddForcedWord('XXXVII')            !37
  SELF.AddForcedWord('XXXVIII')           !38
  SELF.AddForcedWord('XXXIX')             !39
  SELF.AddForcedWord('XL')                !40
  SELF.AddForcedWord('XLI')               !41
  SELF.AddForcedWord('XLII')              !42
  SELF.AddForcedWord('XLIII')             !43
  SELF.AddForcedWord('XLIV')              !44
  SELF.AddForcedWord('XLV')               !45
  SELF.AddForcedWord('XLVI')              !46
  SELF.AddForcedWord('XLVII')             !47
  SELF.AddForcedWord('XLVIII')            !48
  SELF.AddForcedWord('XLIX')              !49

  !Particles
  SELF.AddForcedWord('de')
  SELF.AddForcedWord('du')
  SELF.AddForcedWord('la')                !Bad for French
  SELF.AddForcedWord('los')
  SELF.AddForcedWord('van')
  SELF.AddForcedWord('von')

  !Articles and Conjunctions
  SELF.AddForcedWord('a'  , True)
  SELF.AddForcedWord('an' , True)
  SELF.AddForcedWord('and', True)
  SELF.AddForcedWord('of' , True)
  SELF.AddForcedWord('the', True)
!==============================================================================
MHProperClass.Destruct PROCEDURE
  CODE
  SELF.DisposeName
  SELF.RemoveForcedWords
  DISPOSE(SELF.ForcedWord)
!==============================================================================
MHProperClass.DisposeForcedWord PROCEDURE(LONG X)!,BYTE
  CODE
  GET(SELF.ForcedWord, X)
  IF ERRORCODE() = 0
    DISPOSE(SELF.ForcedWord.Word)
    DISPOSE(SELF.ForcedWord.PaddedUpper)
    DELETE(SELF.ForcedWord)
    RETURN 0
  ELSE
    RETURN 1
  END
!==============================================================================
MHProperClass.DisposeName PROCEDURE
  CODE
  DISPOSE(SELF.Name)
  SELF.Length = 0
!==============================================================================
MHProperClass.HandleForcedWords PROCEDURE
N &STRING
P LONG,AUTO
X LONG,AUTO
  CODE
  !--- Massage name to have padded ends and non-alpha switched to spaces
  N &= NEW STRING(SELF.Length+2)
  N  = ' ' & UPPER(SELF.Name) & ' '
  LOOP X = SELF.Length + 1 TO 2 BY -1
    IF NOT (ISALPHA(N[X]) OR NUMERIC(N[X]) OR N[X]='''')
      N[X] = ' '
    END
  END

  LOOP X = 1 TO RECORDS(SELF.ForcedWord)
    GET(SELF.ForcedWord, X)
    P = CHOOSE(~SELF.ForcedWord.NotAtStart, 1, 2)
    LOOP
      P = INSTRING(SELF.ForcedWord.PaddedUpper, N, 1, P)
      IF P = 0 THEN BREAK.
      SELF.Name[P : P + SELF.ForcedWord.Length - 1] = SELF.ForcedWord.Word
      P += 1
    END
  END
  DISPOSE(N)
!==============================================================================
MHProperClass.ToProper PROCEDURE(STRING Name)!,STRING
Mc LONG(-2)
X  LONG,AUTO
  CODE
  SELF.DisposeName

  SELF.Length = LEN(CLIP(Name))
  IF SELF.Length = 0
    RETURN ''

  ELSE
    SELF.Name &= NEW STRING(SELF.Length)
    SELF.Name  = Name

    LOOP X = 1 TO SELF.Length
      IF ISALPHA(SELF.Name[X])
        IF X = 1
          SELF.Name[X] = UPPER(SELF.Name[X])
        ELSIF ISALPHA(SELF.Name[X-1])
          IF Mc = X - 2
            SELF.Name[X] = UPPER(SELF.Name[X])
          ELSE
            SELF.Name[X] = LOWER(SELF.Name[X])
            IF SELF.Name[X]='c' AND SELF.Name[X-1]='M'
              Mc = X - 1
            END
          END
        ELSIF UPPER(SELF.Name[X]) = 'S' AND SELF.Name[X-1] = ''''
          IF X = SELF.Length OR ~ISALPHA(SELF.Name[X+1])  !End of the word?
            SELF.Name[X] = 's'
          ELSE
            SELF.Name[X] = 'S'
          END
!       ELSIF ISDIGIT(SELF.Name[X-1])
!         SELF.Name[X] = LOWER(SELF.Name[X])
        ELSE
          SELF.Name[X] = UPPER(SELF.Name[X])
        END
      END
    END
    SELF.HandleForcedWords
    RETURN SELF.Name
  END
!==============================================================================
MHProperClass.RemoveForcedWord PROCEDURE(STRING Word)!,BYTE
  CODE
  SELF.ForcedWord.Word = Word
  GET(SELF.ForcedWord, SELF.ForcedWord.Word)  !May fail, but that's OK
  IF ERRORCODE() = 0
    RETURN SELF.DisposeForcedWord(POINTER(SELF.ForcedWord))
  ELSE
    RETURN 1
  END
!==============================================================================
MHProperClass.RemoveForcedWords PROCEDURE
  CODE
  LOOP WHILE SELF.DisposeForcedWord(1) = 0.
!==============================================================================
